<?php

#############################################################################
#                                                                           #
# GXGetUrl Version 0.1 beta 1                                               #
# Copyright 2004 Luc Saffre                                                 #
# Copyright 2007 Gerd Xhonneux                                              #
# http://xtc.xhonneux.com                                                   #
#                                                                           #
# This program is free software; you can redistribute it and/or modify      #
# it under the terms of the GNU General Public License as published by      #
# the Free Software Foundation; either version 2 of the License, or         #
# (at your option) any later version.                                       #
#                                                                           #
# This program is distributed in the hope that it will be useful,           #
# but WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
# GNU General Public License for more details.                              #
#                                                                           #
# You should have received a copy of the GNU General Public License         #
# along with this program; if not, write to the Free Software               #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA   #
#                                                                           #
#############################################################################

function GXGetUrl($base,$default) {

GLOBAL $su, $sl, $plugin_cf, $plugin_tx, $pth, $plugin;

  /*
    - replace relative links in content by absolute links
   
    note: considered as relative link is anything between the '"' of a
    href="" or src="" tag that does not contain a ":"
    character. If it contains a ":", then it is not modified.
 
    if GXGetUrl fails there is not output at all. If you want to know
    why it failed, remove the "@" in front of fopen so that PHP will
    display a warning. Or uncomment the last two lines.
   
  */

  $t='';
  if(substr($base,-1,1) != '/') $base .= '/';
  $urlx = $_GET['urlx'];
  if(strlen($urlx) == 0)
    $u = $base . $default;
  else
    $u = $base . $urlx;
  $u = rawurldecode($u);
  $u = preg_replace("/\&/is","&",$u);
  if($fh=@fopen($u,"r")){
    while(!feof($fh))
      $t.=fread($fh, 1024);
    fclose($fh);
   
    $t = preg_replace("/.*<body[^>]*>(.*)<\/body>.*/is","\\1",$t);
    $t = preg_replace("/src=\"([^\":]*)\"/is","src=\"$base\\1\"",$t);
    $t = preg_replace("/window.open\('([^':]*)'/is",
                      "window.open('$base\\1'",$t);
 
    $t = preg_replace_callback("/href=\"([^\":]*)\"/is",
                               "GXGetUrl_replace",
                               $t);
    
    // Show source informations?
    if 	($plugin_cf['gxgeturl']['show_source']) {
      $t .= "<br>".$plugin_tx['gxgeturl']['source_copyright']."<a href='".$u."'>".$u."</a>";
    }
  } else {
        $t = $plugin_tx['gxgeturl']['could_not_open']."<a href='".$u."'>".$u."</a>";
    }
  return $t;  
}
 
 
function GXGetUrl_replace($matches) {
  /*
    callback function for preg_replace_callback used in GXGetUrl
   
    $matches[0] is the complete match
   
    $matches[1] the match for the first subpattern enclosed in '(...)'
    and so on
   
   */
  $uri = $_SERVER['REQUEST_URI'];
  $pos = strpos($uri,'urlx=');
  $newurl = '';
  if ($pos) {
    $self = substr($uri,0,$pos-1);
    $urlx=rawurldecode(substr($uri,$pos+5));
    if(strpos($urlx,'&')==false) {
      $rpos = strrpos($urlx,'/');
      if ($rpos)
        $newurl = substr($urlx,0,$rpos+1);
    }
  } else $self = $uri;
 
 
  $newurl .= $matches[1];
      
  if (strpos($self,"?") === false)
    $self .= "?urlx=";
  else
    $self .= "&urlx=";
 
  $self .= rawurlencode($newurl);
      
  return 'href="' . $self . '"';
}
?>
